function generateinput(Rsvpstream,Lag)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Copyright Notice
% This software is the intellectual property of Brad Wyble and Patrick Craston, 2006
% It may be download and used freely.  
% This code may be included in other published works with the permission of the authors, 
% who can be contacted at bwyble @ gmail.com  (remove spaces)


%Using targvals, which is computed in perfcheck.m  (called by runRSVP) we
%check to see if the target is seen and compute the swaps
% generates an input vector from an RSVP stream based on the parameters
%It uses the data structure generated by inputpatterns (which is passed in
%through the parameter Rsvpstream) as well as various global parameters to
%determine the time step by timestep resolution.

%Distractors are used in increasing order starting from item #11.
%T1 and T2 are always items 1 and 2.
global NUMINPUTS NUMITEMS
global Retina stepperlag itemperlag
global T1BLANK T2BLANK T1BLANK2 FORWARDMASK NUMTARGS NUMDISTRACTORS
global genval genval2 distval Equalgens whichds 

dist = 0;
FORWARDMASK = 0;
Retina = 0;

for (i = 1:NUMITEMS)
    if(Equalgens)    %when in a hurry, we test with T1 = T2
        genval2 = genval;
    end
    if(Rsvpstream(Lag,i,1))  %T1
        val = genval;
    elseif(Rsvpstream(Lag,i,2))  %T2
        val = genval2;
    else   %distractors
        val = distval;
    end
    %copy the items into the "retina"
    tempret = zeros(1,NUMINPUTS);
    tempret(1,1:2) = reshape(Rsvpstream(Lag,i,1:2),[1,2]) * val;  % copy the 2 items
    dodistractor = 1;

    if(Rsvpstream(Lag,i,3) == 2)  %are we doing a sequential distractor at this lag?
        if(i > 2 & i <= size(Rsvpstream,2))
            %Various blank conditions
            if(T1BLANK)   %T1 + 1 Blank
                if(~FORWARDMASK & (Rsvpstream(Lag,i-1,1)))
                    dodistractor = 0;
                end
                if(FORWARDMASK & (Rsvpstream(Lag,i+1,1)))
                    dodistractor = 0;
                end
            end
            if(T1BLANK2)   %T1 + 2 Blank
                if(~FORWARDMASK & (Rsvpstream(Lag,i-2,1)))
                    dodistractor = 0;
                end
                if(FORWARDMASK & (Rsvpstream(Lag,i+1,1)))
                    dodistractor = 0;
                end
            end
            if(T2BLANK)     %T2 +1-N Blank
                sum((Rsvpstream(Lag,1:i-1,2)) > 0);
                if(~FORWARDMASK & sum((Rsvpstream(Lag,1:i-1,2)) > 0))
                    dodistractor = 0;
                end
                if(FORWARDMASK & (Rsvpstream(Lag,i+1,2)))
                    dodistractor = 0;
                end
            end
        end

        %which distractor item is present in this slot of the RSVP stream
        %We reuse distractor items if we go beyond 10, starting at 1 again
        whichd = mod(dist,NUMDISTRACTORS) + 1 + NUMTARGS;
        if(dodistractor)
            tempret(1,whichd) = val;
            dist = dist + 1;
        end
        whichds(i) = whichd;
    end

    for(j= 1: stepperlag)   %now fill in the actual bits of items for each 5 ms timestep
        tindex = (i-1)*stepperlag+j;
        if(j <= itemperlag)
            Retina(tindex,1:NUMINPUTS) = tempret;
        else   % this would create an ISI, if we had one
            Retina(tindex,1:NUMINPUTS) = zeros(1,NUMINPUTS);
        end
    end
end






