function inputpatterns
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Copyright Notice
% This software is the intellectual property of Brad Wyble and Patrick Craston, 2006
% It may be download and used freely.  
% This code may be included in other published works with the permission of the authors, 
% who can be contacted at bwyble @ gmail.com  (remove spaces)
%Using targvals, which is computed in perfcheck.m  (called by runRSVP) we
%check to see if the target is seen and compute the swaps
global BASICRSVP SOA NUMITEMS NUMSTREAMS stepperlag itemperlag totalsteps blankperlag runlength onetarg

% at what time do we present T1 and T2

%   0,0,2,0;...       =  present a distractor
%   1,0,0,0;...       =  present T1
%   0,1,0,0;...         = present T2

%first dimension of the matrix is the lag

%SOA 100 msec, 0 ms ISI
LAGLENGTH = SOA; %msec
ITEMLENGTH = SOA; %msec

TIMESTEP = 5;  %millisec

if(SOA == 100)
    %length of RSVP stream
    NUMITEMS = 18;
    if(onetarg)

        %this is the number of lags
        NUMSTREAMS = 8;

        BASICRSVP = zeros(NUMSTREAMS,NUMITEMS,4);
        sprintf('Using %d ms SOA. %d items in stream. 1 target only',SOA,size(BASICRSVP,2))
        BASICRSVP(1,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0] ;
    else

        %this is the number of lags
        NUMSTREAMS = 8;

        BASICRSVP = zeros(NUMSTREAMS,NUMITEMS,4);

        sprintf('Using %d ms SOA. %d items in stream',SOA,size(BASICRSVP,2))

        %lag 1
        BASICRSVP(1,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0] ;
        %lag 2...etc
        BASICRSVP(2,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0] ;

        BASICRSVP(3,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0] ;


        BASICRSVP(4,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0] ;


        BASICRSVP(5,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0] ;


        BASICRSVP(6,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0] ;


        BASICRSVP(7,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0] ;


        BASICRSVP(8,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0] ;
    end
elseif(SOA == 50)
    %length of RSVP stream
    NUMITEMS = 26;
    BASICRSVP = zeros(8,NUMITEMS,4);

    if(onetarg)

        %this is the number of lags
        NUMSTREAMS = 8;

        BASICRSVP = zeros(NUMSTREAMS,NUMITEMS,4);
        sprintf('Using %d ms SOA. %d items in stream. 1 target only',SOA,size(BASICRSVP,2))
        BASICRSVP(1,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...            
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...            
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0 ] ;
    else
        %this is the number of lags
        NUMSTREAMS = 8;

        BASICRSVP = zeros(NUMSTREAMS,NUMITEMS,4);
        sprintf('Using %d ms SOA. %d items in stream',SOA,size(BASICRSVP,2))
        BASICRSVP(1,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0 ] ;
        BASICRSVP(2,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0 ] ;
        BASICRSVP(3,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0 ] ;
        BASICRSVP(4,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0] ;
        BASICRSVP(5,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0 ] ;
        BASICRSVP(6,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0] ;
        BASICRSVP(7,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0] ;
        BASICRSVP(8,:,:) = [0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            1,0,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,1,0,0;...
            0,0,2,0;...
            0,0,2,0;...
            0,0,2,0] ;
    end
end

%calculate number of steps to run the model for.
stepperlag = LAGLENGTH/TIMESTEP;
itemperlag =  ITEMLENGTH/TIMESTEP;
blankperlag = stepperlag - itemperlag;
%single timestep is equal to SOA/5 milliseconds
totalsteps = stepperlag * (NUMITEMS);
runlength = totalsteps+200; % pad it by 200 time steps beyond the last item
